;;; Definim la classe Animal, amb el multi-slot color

(defclass Animal
  (is-a USER)
  (role concrete)
  (multislot color (cardinality 1 4) (type SYMBOL) 
             (allowed-values Blanc Negre Verd Groc Blau)
             (create-accessor read-write))
)

;;; El missatge info-colors ens diu quants colors te un animal, i quin es el primer
;;; Funcions:
;;;    (length llista): torna la longitut de la llista
;;;    (nth posici llista): torna l'element de la llista de la posici donada
;;; Els parametres i variables sempre porten un ? al davant

(defmessage-handler Animal info-colors ()
  (bind ?llcol ?self:color)
  (bind ?ncol (length ?llcol))
  (bind ?prcol (nth 1 ?llcol))
  (printout T "Hi han " ?ncol " colors, i el primer es el " ?prcol crlf)
)

;;; El missatge tots-colors-i-esborra ens diu tots els colors d'un animal i l'esborra
;;; Funci loop-for-count (variable de control, valor inicial, valor final)
;;; Fem manegadors primary, before (abans) i after (despres)
;;; La funcio instance-name ens torna el nom d'un objecte

(defmessage-handler Animal tots-colors-i-esborra ()
  (loop-for-count (?ind 1 (length ?self:color))
     (printout T "Color numero " ?ind " ....." (nth ?ind ?self:color) crlf)
  )
)

(defmessage-handler Animal tots-colors-i-esborra before ()
  (printout T "A continuacio escriure els colors de " (instance-name ?self) crlf)
  (printout T "**********************************************" crlf)
)

(defmessage-handler Animal tots-colors-i-esborra after ()
  (printout T "**********************************************" crlf)
  (send ?self delete)
)

;;; Altres construccions utils de CLIPS
;;;
;;; (mv-append ?llista ?elem)           Afegeix un element a una llista
;;; (mv-delete ?posicio ?llista)        Elimina de la llista l'element que esta a la posicio
;;; (if condicio then .... else ....)   Estructura condicional
;;; (pi)                                Torna el numero pi (3.141592...)
