;;; Netegem l'entorn CLIPS i carregem les definicions
;;; de classes.

(clear)
(load "regles.clp")

;;; Fem instancies d'alguns animals.

(make-instance MobyDick of BalenesBlaves)
(make-instance BigMobyDick of BalenesBlaves (pes 4500))
(make-instance VeryBigMobyDick of BalenesBlaves (pes 7000))
(make-instance Bally of BalenesArtiques)
(make-instance BigBally of BalenesArtiques (pes 8000))
(make-instance Dufi of Dofins (color negre))
(make-instance Dufi2 of Dofins (color blau))


;;; Exemples d'utilitzacio de regles

;;; Regla per eliminar tots els animals blaus.

(defrule elimina-blau
    ?obj <- (object (is-a Animals) (color blau))
    =>
    (printout T "He trobat un animal blau, amb aquestes dades:" crlf)
    (send ?obj print)   
    (send ?obj delete)
    (printout T "Animal esborrat" crlf)
)

;;; Regla per veure les dades de les balenes
;;; d'un pes superior a 4000.
;;; L'expressio "&:" serveix per concatenar 2 condicions.

(defrule balenes-enormes 
    ?obj <- (object (is-a Balenes) (pes ?p &:(> ?p 4000)))
    =>
    (printout T "He trobat una balena de pes superior
     a 4000, que te aquestes dades:" crlf)
    (send ?obj print)
)

;;; Regla per trobar l'animal mes pesat

(defrule mes-pesat
   (object (is-a Animals) (pes ?p))
   (not (object (is-a Animals) (pes ?q &:(> ?q ?p))))
   =>
   (printout T "L'animal mes pesat te un pes de " ?p crlf)
)

;;; Regla per canviar el color dels animals aquatics a blaus

(defrule pas-a-blau
    ?obj <- (object (is-a AnimalsAquatics) (color ~blau))
    =>
    (printout T (instance-name ?obj) " s un animal aquatic no blau." crlf)
    (send ?obj put-color blau)
    (printout T "Ara ja es blau." crlf)
    (send ?obj print)
)


;;; Regla per trobar una balena blava i una artica que pesin igual

(defrule mateix-pes
   (object (is-a BalenesBlaves) (pes ?p))
   (object (is-a BalenesArtiques) (pes ?p))
   =>
   (printout T "Hi ha una balena blava i una artica que pesen igual: " ?p crlf)
)


